



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>EndPoint详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">EndPoint详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 00:27:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>EndPoint详解</h3>
<p>EndPoint主要用于暴露一些SpringMvc内部运行的信息，通常是通过SpringMvc的请求地址获取相关信息。如/health获取健康检查信息。</p>
<h4>简单单元测试</h4>
<pre class="prettyprint linenums"><code>@Test<br />
public void testHealth() throws Exception{<br />
  mockMvc.perform(MockMvcRequestBuilders.get(&quot;/health&quot;).contentType(MediaType.APPLICATION_JSON_UTF8)).andDo(new ResultHandler() {<br />
    @Override<br />
    public void handle(MvcResult result) throws Exception {<br />
      System.out.println(result.getResponse().getContentAsString());<br />
    }<br />
  });<br />
}<br />
</code></pre>
<pre class="prettyprint linenums"><code>//结果<br />
{&quot;status&quot;:&quot;UP&quot;,&quot;discoveryComposite&quot;:{&quot;description&quot;:&quot;Discovery Client not initialized&quot;,&quot;status&quot;:&quot;UNKNOWN&quot;,&quot;discoveryClient&quot;:{&quot;description&quot;:&quot;Discovery Client not initialized&quot;,&quot;status&quot;:&quot;UNKNOWN&quot;}},&quot;diskSpace&quot;:{&quot;status&quot;:&quot;UP&quot;,&quot;total&quot;:197553815552,&quot;free&quot;:46789115904,&quot;threshold&quot;:10485760},&quot;refreshScope&quot;:{&quot;status&quot;:&quot;UP&quot;},&quot;hystrix&quot;:{&quot;status&quot;:&quot;UP&quot;},&quot;consul&quot;:{&quot;status&quot;:&quot;UP&quot;,&quot;services&quot;:{&quot;consul&quot;:[]},&quot;advertiseAddress&quot;:&quot;172.17.0.8&quot;,&quot;datacenter&quot;:&quot;dc1&quot;,&quot;domain&quot;:&quot;consul.&quot;,&quot;nodeName&quot;:&quot;node-client-v-5-1&quot;,&quot;bindAddress&quot;:&quot;0.0.0.0&quot;,&quot;clientAddress&quot;:&quot;0.0.0.0&quot;}}<br />
</code></pre>
<h4>url映射</h4>
<p>HandlerMapping使用EndpointHandlerMapping，重写了registerHandlerMethod，主要是注册HandlerMethod时重写请求路径。</p>
<pre class="prettyprint linenums"><code>private String[] getPatterns(Object handler, RequestMappingInfo mapping) {<br />
  String path = getPath(handler);<br />
  String prefix = StringUtils.hasText(this.prefix) ? this.prefix + path : path;<br />
  Set&lt;String&gt; defaultPatterns = mapping.getPatternsCondition().getPatterns();<br />
  if (defaultPatterns.isEmpty()) {<br />
    return new String[] { prefix, prefix + &quot;.json&quot; };<br />
  }<br />
  List&lt;String&gt; patterns = new ArrayList&lt;String&gt;(defaultPatterns);<br />
  for (int i = 0; i &lt; patterns.size(); i++) {<br />
    patterns.set(i, prefix + patterns.get(i));<br />
  }<br />
  return patterns.toArray(new String[patterns.size()]);<br />
}<br />
</code></pre>
<pre class="prettyprint linenums"><code>private String getPath(Object handler) {<br />
  if (handler instanceof String) {<br />
    handler = getApplicationContext().getBean((String) handler);<br />
  }<br />
  if (handler instanceof MvcEndpoint) {<br />
    return ((MvcEndpoint) handler).getPath();<br />
  }<br />
  return &quot;&quot;;<br />
}<br />
</code></pre>
<p>如果handler时MvcEndpoint类型，则请求路径调用getPath方法获取。</p>
<h4>健康检查为例/health</h4>
<h5>实现</h5>
<pre class="prettyprint linenums"><code>public HealthEndpoint(HealthAggregator healthAggregator,<br />
    Map&lt;String, HealthIndicator&gt; healthIndicators) {<br />
  super(&quot;health&quot;, false);<br />
  Assert.notNull(healthAggregator, &quot;HealthAggregator must not be null&quot;);<br />
  Assert.notNull(healthIndicators, &quot;HealthIndicators must not be null&quot;);<br />
  CompositeHealthIndicator healthIndicator = new CompositeHealthIndicator(<br />
      healthAggregator);<br />
  for (Map.Entry&lt;String, HealthIndicator&gt; entry : healthIndicators.entrySet()) {<br />
    healthIndicator.addHealthIndicator(getKey(entry.getKey()), entry.getValue());<br />
  }<br />
  this.healthIndicator = healthIndicator;<br />
}<br />
</code></pre>
<pre class="prettyprint linenums"><code>@Override<br />
	public Health invoke() {<br />
		return this.healthIndicator.health();<br />
	}<br />
</code></pre>
<p>最终回调用HealthIndicator的health()方法。而健康检查的HealthIndicator为CompositeHealthIndicator。其health方法：</p>
<pre class="prettyprint linenums"><code>@Override<br />
public Health health() {<br />
  Map&lt;String, Health&gt; healths = new LinkedHashMap&lt;String, Health&gt;();<br />
  for (Map.Entry&lt;String, HealthIndicator&gt; entry : this.indicators.entrySet()) {<br />
    healths.put(entry.getKey(), entry.getValue().health());<br />
  }<br />
  return this.healthAggregator.aggregate(healths);<br />
}<br />
</code></pre>
<p>所以，HealthIndicator才是最为关键的，CompositeHealthIndicator只是将所有的HealthIndicator合并。</p>
<h5>自定义健康检查实现，即实现HealthIndicator。</h5>
<pre class="prettyprint linenums"><code>@Component<br />
public class TestHelthIndicator extends AbstractHealthIndicator {<br />
    @Override<br />
    protected void doHealthCheck(Health.Builder builder) throws Exception {<br />
        builder.up().withDetail(&quot;test&quot;,&quot;testHealth&quot;);<br />
    }<br />
}<br />
</code></pre>
<pre class="prettyprint linenums"><code>&quot;testHelthIndicator&quot;:{&quot;status&quot;:&quot;UP&quot;,&quot;test&quot;:&quot;testHealth&quot;},<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4953n608.html">android 学习中的一些问题记录 主要是概念问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv07mo8.html">Windows Store App JavaScript 开发：小球运动示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwrek39.html">iOS&lowbar;地图之显示附近微博</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z6yrdq.html">如何让openvpn在windows启动时自动加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwxdo39.html">C&num;之发送邮件汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvl03x8.html">solr多core的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlyzxk9.html">Vijos 1061  迎春舞会之三人组舞&lpar;DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeg5kz9.html">cent0s7 显卡驱动导致重启黑屏</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06pmeq.html">LabVIEW设计模式系列&mdash;&mdash;移位寄存器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydnregq.html">iOS网络层架构设计分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvm20xq.html">Java 可视化垃圾回收</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvynroq.html">【前端JS】input textarea 默认文字，点击消失</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v60jq.html">CodeIgniter Apacheserver htaccess SEO重写写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj5jr1q.html">纪中集训 Day 2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gez7208.html">php数组合并，反转，去重，添加元素等；</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22yg2q.html">Oracle列转行函数使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvll138.html">Implemented Energy-Conserving Hair Scattering Model from Weta Digital</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzp5vq.html">Java 模拟面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gvw1mq.html">如何创建带有大纲和书签的交互式web报表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldwnkq.html">Object类--toString方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495e72v9.html">Ajax2</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jox1eq.html">codeforces 732&sol;D 二分</a>
			</li>
						<li><a href="https://www.batexi.com/a/495enp69.html">DUILIB 背景贴图</a>
			</li>
						<li><a href="https://www.batexi.com/a/r934lyg8.html">github 项目版本控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/495evge9.html">android中如何发送及接收数据&lpar;两种方法&rpar;？</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g7v2e9.html">Spring MVC&plus;Spring &plus;Hibernate配置事务，但是事务不起作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q755mg9.html">Jade之Interpolation</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m55y2q.html">linux 安装jdk&comma;tomcat 配置vsftp 远程连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jooogq.html">理解RHEL上安装oracle的配置参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7554e9.html">Java将文本写入字符输出流，缓冲各个字符，从而提供单个字符、数组和字符串的高效写入。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
